// **************************************************************************
// *                                                                        *
// *     MOBL - 1999 by Workshop Of Success (TM), using K-D Lab idea        *
// *                                                                        *
// *              DISTRIBUTE THIS SHIT! THIS IS FREEWARE!                   *
// *                                                                        *
// *                                                            Have fun... *
// **************************************************************************

#include "mobl.h"

// ==========================================================================
int new_game = 1, is_pause = 1, done = 0, won = 0;
bitmap cur("data\\cur.spr");
int m_step = 0, m_dir = 1, m_count;
bitmap border[4];
// bitmap btns[max_btns];
bitmap b_balls("data\\balls.spr");
bitmap b_cells("data\\cells.spr");
bitmap b_bwcells("data\\bwcells.spr");
bitmap playb("data\\playb.spr");
bitmap digits("data\\digits.spr");
bitmap buttons("data\\pressed.spr");
bitmap gameover("data\\gameover.spr");
bitmap gameend("data\\gameend.spr");
int clr1, clr2, rule;
long unsigned cur_time;
cell map[max_x][max_y];
ball balls[max_balls_count];
int balls_count[3];
int painted;
int centres[max_btns][2] =
{
    219,  72, 246,  72, 275,  71, 304,  71,
    219, 109, 246, 108, 276, 109, 304, 109,
    219, 152, 247, 152, 277, 152, 303, 152
};
// ==========================================================================
void show_number(long number, int x, int y, int space)
{
    for (int i = 0; i < space; i++)
    {
        int dig = number % 10;
        number /= 10;
        digits.blt_fast(x + (space - i - 1) * 8, y, dig * 8, 0, 8, 10);
    };
};
// --------------------------------------------------------------------------
int ball_hit(int search_for, int start_index)
{
    ball *target = balls + search_for;
    ball *bptr = &balls[start_index];
    for (int i = start_index; i < max_balls_count; i++)
    {
        if (bptr->present && target != bptr)
        {
            if (dist(bptr->x, bptr->y, target->x, target->y)
                < 2 * ball_radius)
            {
                return bptr - balls;
            };
        };
        bptr++;
    };
    return -1;
};
// --------------------------------------------------------------------------
void create_ball(int status)
{
    ball *ptr = balls;
    for (int i = 0; i < max_balls_count; i++)
    {
        if (!ptr->present) break;
        ptr++;
    };
    if (i != max_balls_count)
    {
        int saver = 1000;
        do {
            ptr->x = (double) random(17400) / 100;
            ptr->y = (double) random(17400) / 100;
            ptr->dx = (double) random(4000) / 1000 - 2;
            ptr->dy = (double) random(4000) / 1000 - 2;
            ptr->present = 1;
            ptr->count = 0;
            ptr->stat = status;
            if (saver-- < 0) error("Ball creation error: no more room!\n");
        } while(ball_hit(i, 0) != -1);
        if (ptr->stat < 3)
        {
            balls_count[ptr->stat]++;
        };
    };
};
// --------------------------------------------------------------------------
void destroy_ball(ball *bptr)
{
    if (bptr->present)
    {
        bptr->present = 0;
        if (bptr->stat != bs_white)
            balls_count[bptr->stat % 3]--;
    };
};
// --------------------------------------------------------------------------
void load_bitmap_array(bitmap *ptr, int count, char *name)
{
    char str_val[18], str_base[64];
    bitmap *cur = ptr;
    for (int i = 0; i < count; i++)
    {
        strcpy(str_base, name);
        strcat(str_base, itoa(i, str_val, 10));
        strcat(str_base, ".spr");
        cur->load_from_file(str_base);
        cur++;
    };
};
// --------------------------------------------------------------------------
void new_game_init()
{
    clr1 = 3;
    clr2 = 3;
    rule = 3;
    won = 0;
    painted = 0;
    cur_time = 0;
    // Cells init
    cell *ptr = map[0];
    for (int i = 0; i < max_x; i++)
    {
        for (int j = 0; j < max_y; j++)
        {
            ptr->stat = cs_white;
            ptr->click = 0;
            ptr++;
        };
    };
    // Balls init
    ball *bptr = balls;
    for (i = 0; i < max_balls_count; i++)
    {
        bptr->present = 0;
        bptr++;
    };
    balls_count[0] = 0;
    balls_count[1] = 0;
    balls_count[2] = 0;
    for (i = 0; i < start_balls_count; i++)
    {
        create_ball(random(3));
    };
    create_ball(bs_white);
};
// --------------------------------------------------------------------------
void do_tick()
{
    // For cells
    cell *ptr = map[0];
    for (int i = 0; i < max_x * max_y; i++)
    {
        int black_count = 4;
        if (i % max_x <= 0 || (ptr - 1)->stat == cs_black) black_count--;
        if (i / max_y <= 0 || (ptr - 30)->stat == cs_black) black_count--;
        if (i % max_x >= max_x - 1 || (ptr + 1)->stat == cs_black)
            black_count--;
        if (i / max_y >= max_y - 1 || (ptr + 30)->stat == cs_black)
            black_count--;
        if (ptr->stat != cs_black && black_count <= 0)
        {
            painted++;
            ptr->stat = cs_black;
        }
        else if (ptr->stat != cs_white && ptr->stat != cs_black)
        {
            ptr->click++;
            if (ptr->stat == cs_red_end ||
                ptr->stat == cs_green_end ||
                ptr->stat == cs_blue_end)
            {
                if (ptr->click > click_lim * 18 * 2)
                {
                    ptr->click = 0;
                    ptr->stat = cs_white;
                };
            }
            else
            {
                if (ptr->click > click_lim)
                {
                    ptr->click = 0;
                    ptr->stat++;
                };
            };
        };
        ptr++;
    };
    // For balls
    ball *bptr = balls;
    for (i = 0; i < max_balls_count; i++)
    {
        if (bptr->present)
        {
            if (bptr->stat == bs_red || bptr->stat == bs_green ||
                bptr->stat == bs_blue)
            {
                if (++bptr->count > ball_max_free_time)
                {
                    bptr->stat += 3;
                    bptr->count = 0;
                };
            };
            // Change cell
            cell *cptr = &map[(int)(bptr->y + ball_radius) / 6]
                             [(int)(bptr->x + ball_radius) / 6];
            // Results maybe various
            if (bptr->stat == bs_white)
            {
                if (cptr->stat != cs_black)
                {
                    cptr->stat = cs_white;
                };
            }
            else
            {
                if (cptr->stat != cs_black && cptr->stat != cs_red_end &&
                    cptr->stat != cs_green_end && cptr->stat != cs_blue_end)
                {
                    if ((cptr->stat == cs_white) ||
                        (cptr->stat / 18 != bptr->stat % 3))
                    {
                        cptr->stat = (bptr->stat % 3) * 18;
                    };
                }
                else if ((bptr->dx == 0) && (bptr->dy == 0) &&
                         cptr->stat != cs_black &&
                         cptr->stat / 18 == bptr->stat % 3)
                {
                    // !!!
                    int black_count = 0, non_cooled_count = 0;
                    if (i % max_x > 0)
                    {
                        if ((cptr - 1)->stat == cs_black) black_count++;
                        else if ((cptr - 1)->stat != cs_red_end &&
                                 (cptr - 1)->stat != cs_green_end &&
                                 (cptr - 1)->stat != cs_blue_end)
                        {
                            non_cooled_count++;
                        };
                    };
                    if (i / max_y > 0)
                    {
                        if ((cptr - 30)->stat == cs_black) black_count++;
                        else if ((cptr - 30)->stat != cs_red_end &&
                                 (cptr - 30)->stat != cs_green_end &&
                                 (cptr - 30)->stat != cs_blue_end)
                        {
                            non_cooled_count++;
                        };
                    };
                    if (i % max_x < max_x - 1)
                    {
                        if ((cptr + 1)->stat == cs_black) black_count++;
                        else if ((cptr + 1)->stat != cs_red_end &&
                                 (cptr + 1)->stat != cs_green_end &&
                                 (cptr + 1)->stat != cs_blue_end)
                        {
                            non_cooled_count++;
                        };
                    };
                    if (i / max_y < max_y - 1)
                    {
                        if ((cptr + 30)->stat == cs_black) black_count++;
                        else if ((cptr + 30)->stat != cs_red_end &&
                                 (cptr + 30)->stat != cs_green_end &&
                                 (cptr + 30)->stat != cs_blue_end)
                        {
                            non_cooled_count++;
                        };
                    };
                    if (black_count > 0 || non_cooled_count <= 0)
                    {
                        cptr->stat = cs_black;
                        painted++;
                        destroy_ball(bptr);
                    }
                    else
                    {
                        cptr->stat = cs_white;
                    };
                };
            };
            if (bptr->present && (bptr->stat == bs_l_red ||
                bptr->stat == bs_l_green || bptr->stat == bs_l_blue) &&
                cptr->stat != cs_black)
            {
                if (!(clr1 == 3 && clr2 == 3) && (clr1 == 3 || clr2 == 3)
                    && (bptr->stat % 3 == clr1 || bptr->stat % 3 == clr2))
                {
                    int old_stat, i, subzero;
                    int pot_balls = 0;
                    ball *bp;
                    switch (rule)
                    {
                    case 0:
                        destroy_ball(bptr);
                        break;
                    case 2:
                        for (i = 0, bp = balls; i < max_balls_count; i++, bp++)
                        {
                            if (bp->present && bp->stat != bptr->stat)
                            {
                                pot_balls++;
                            };
                        };
                        if (pot_balls == 0) error("BAD pot_balls!\n");
                        for (i = 0, bp = balls; i < max_balls_count; i++, bp++)
                        {
                            if (bp->present && bp->stat != bptr->stat)
                            {
                                subzero = 0;
                                if (bp->dx < 0) subzero = 1;
                                bp->dx = sqrt((pot_balls * bp->dx * bp->dx +
                                              bptr->dx * bptr->dx) / pot_balls);
                                if (subzero) bp->dx = -bp->dx;
                                subzero = 0;
                                if (bp->dy < 0) subzero = 1;
                                bp->dy = sqrt((pot_balls * bp->dy * bp->dy +
                                              bptr->dy * bptr->dy) / pot_balls);
                                if (subzero) bp->dy = -bp->dy;
                            };
                        };
                        bptr->dx = 0;
                        bptr->dy = 0;
                        break;
                    case 3:
                        old_stat = bptr->stat % 3;
                        destroy_ball(bptr);
                        create_ball(old_stat);
                        create_ball(old_stat);
                        break;
                    };
                };
            };
            // Check for impact
        if (bptr->present)
        {
            int index = bptr - balls + 1;
            int temp;
            while ((index = ball_hit(bptr - balls, index)) != -1)
            {
                ball *ptr1 = bptr;
                ball *ptr2 = balls + index;
                int do_impact = 1;
                if (cptr->stat == cs_black || clr1 == 3 || clr2 == 3 ||
                    ptr1->stat > bs_blue || ptr2->stat >bs_blue)
                {
                    // Rules not defined!!!
                }
                else
                {
                    if (ptr1->stat == clr2 &&
                        ptr2->stat == clr1)
                    {
                        ptr1 = balls + index;
                        ptr2 = bptr;
                    };
                    if (ptr1->stat == clr1 && ptr2->stat == clr2)
                    {
                        ball *bp;
                        int i, index, pot_balls = 0, subzero;
                        switch (rule)
                        {
                        case 0: // Destroy both of them
                            destroy_ball(ptr1);
                            destroy_ball(ptr2);
                            do_impact = 0;
                            break;
                        case 1: // Repaint second
                            index = 0;
                            if (balls_count[index] > balls_count[1])
                            {
                                index = 1;
                                if (balls_count[index] > balls_count[2])
                                {
                                    index = 2;
                                };
                            };
                            // Hm!!!
                            balls_count[index] += 2;
                            balls_count[ptr1->stat]--;
                            balls_count[ptr2->stat]--;
                            ptr1->stat = index;
                            ptr2->stat = index;
                            break;
                        case 2: // Stop both of them
                            for (i = 0, bp = balls; i < max_balls_count; i++, bp++)
                            {
                                if (bp->present && (bp->dx != 0 || bp->dy != 0 || 
                                    bp->stat != clr1 || bp->stat != clr2))
                                {
                                    pot_balls++;
                                };
                            };
                            if (pot_balls == 0) error("BAD pot_balls!\n");
                            for (i = 0, bp = balls; i < max_balls_count; i++, bp++)
                            {
                                if (bp->present && (bp->dx != 0 || bp->dy != 0 || 
                                    bp->stat != clr1 || bp->stat != clr2))
                                {
                                    subzero = 0;
                                    if (bp->dx < 0) subzero = 1;
                                    bp->dx = sqrt((pot_balls * bp->dx * bp->dx +
                                                  ptr1->dx * ptr1->dx) / pot_balls);
                                    bp->dx = sqrt((pot_balls * bp->dx * bp->dx +
                                                  ptr2->dx * ptr2->dx) / pot_balls);
                                    if (subzero) bp->dx = -bp->dx;
                                    subzero = 0;
                                    if (bp->dy < 0) subzero = 1;
                                    bp->dy = sqrt((pot_balls * bp->dy * bp->dy +
                                                  ptr1->dy * ptr1->dy) / pot_balls);
                                    bp->dy = sqrt((pot_balls * bp->dy * bp->dy +
                                                  ptr2->dy * ptr2->dy) / pot_balls);
                                    if (subzero) bp->dy = -bp->dy;
                                };      
                            };
                            ptr1->dx = 0;
                            ptr1->dy = 0;
                            ptr2->dx = 0;
                            ptr2->dy = 0;
                            break;
                        case 3: // Born in fire
                            if (random(2) == 1) create_ball(ptr1->stat);
                            else create_ball(ptr2->stat);
                            break;
                        default:
                            error("Undefined rule in do_tick()!\n");
                            break;
                        };
                    };
                };
                // At the top of success
                if (dist(ptr1->x + ptr1->dx, ptr1->y + ptr1->dy,
                         ptr2->x + ptr2->dx, ptr2->y + ptr2->dy) >
                    dist(ptr1->x, ptr1->y, ptr2->x, ptr2->y))
                {
                    do_impact = 0;
                };
                if (do_impact)
                {
                    // Do impact
                    // Fine (x,y)
                    ptr1->count = 0;
                    ptr2->count = 0;
                    double x1, y1, x2, y2;
                    if (ptr1->x == ptr2->x)
                    {
                        x1 = x2 = ptr1->x;
                        y1 = ptr1->y + ptr1->dy;
                        y2 = ptr2->y + ptr2->dy;
                    }
                    else if (ptr1->y == ptr2->y)
                    {
                        y1 = y2 = ptr1->y;
                        x1 = ptr1->x + ptr1->dx;
                        x2 = ptr2->x + ptr2->dx;
                    }
                    else
                    {
                        double k1 = (ptr1->y - ptr2->y) /
                                    (ptr1->x - ptr2->x),
                               k2 = - 1 / k1;
                        x1 = (k2 * ptr1->x + k2 * ptr1->dx - k1 * ptr1->x -
                              ptr1->dy) / (k2 - k1);
                        y1 = (k1 * k2 * ptr1->dx + k2 * ptr1->y - k1 * ptr1->y -
                              k1 * ptr1->dy) / (k2 - k1);
                        x2 = (k2 * ptr2->x + k2 * ptr2->dx - k1 * ptr2->x -
                              ptr2->dy) / (k2 - k1);
                        y2 = (k1 * k2 * ptr2->dx + k2 * ptr2->y - k1 * ptr2->y -
                              k1 * ptr2->dy) / (k2 - k1);
                    };
                    // All done
                    double dx = x2 - ptr2->x - x1 + ptr1->x,
                           dy = y2 - ptr2->y - y1 + ptr1->y;
                    ptr1->dx += dx;
                    ptr1->dy += dy;
                    ptr2->dx -= dx;
                    ptr2->dy -= dy;
                };
                // At the end of this SHIT:
                index++;
        };  // if (bptr->present);
            };
        };
        bptr++;
    };
    // Balls moving...
    bptr = balls;
    for (i = 0; i < max_balls_count; i++)
    {
            bptr->x += bptr->dx;
            bptr->y += bptr->dy;
            if (bptr->x < 0)
            {
                bptr->x = -bptr->x;
                bptr->dx = -bptr->dx;
            }
            else if (bptr->x > 181 - 2 * ball_radius)
            {
                bptr->x = 2 * (181 - 2 * ball_radius) - bptr->x;
                bptr->dx = -bptr->dx;
            };
            if (bptr->y < 0)
            {
                bptr->y = -bptr->y;
                bptr->dy = -bptr->dy;
            }
            else if (bptr->y > 181 - 2 * ball_radius)
            {
                bptr->y = 2 * (181 - 2 * ball_radius) - bptr->y;
                bptr->dy = -bptr->dy;
            };
            bptr++;
    };
    // Check for MEGA GAME OVER
    if (balls_count[0] <= 0 || balls_count[1] <= 0 || balls_count[2] <= 0 ||
        balls_count[0] > 200 || balls_count[1] > 200 || balls_count[2] > 200)
    {
        won = -1;
    };
    if (painted >= max_x * max_y)
    {
        won = 1;
    };
};
// --------------------------------------------------------------------------
void timer_click()
{
    if (done) return;
    if (won)
    {
        mouse_pos mp = mouse_get_last(0);
        mp.x /= 2;
        if (mp.count != 0)
        {
            if (dist(mp.x, mp.y, 50 + 51, 60 + 62) <= btns_radius)
            {
                new_game = 1;
                won = 0;
            }
        };
    }
    else if (new_game)
    {
        new_game_init();
        new_game = 0;
    }
    else
    {
        // Standart game running...
        if (!is_pause)
        {
            do_tick();
            cur_time++;
        };
        // Mouse scanning
        mouse_pos mp = mouse_get_last(0);
        mp.x /= 2;
        if (mp.count == 0)
        {
            // Do nothing...
        }
        else if (dist(mp.x, mp.y, 312, 7) <= exit_radius)
        {
            done = 1;
        }
        else if (mp.x >= 265 && mp.x <= 289 &&
                 mp.y >= 36  && mp.y <= 52)
        {
            is_pause = !is_pause;
        }
        else if (mp.x >= 290 && mp.x <= 313 &&
                 mp.y >= 36  && mp.y <= 52)
        {
            new_game = 1;
        }
        else
        {
            // All other buttons check out
            for (int i = 0; i < max_btns; i++)
            {
                if (dist(mp.x, mp.y, centres[i][0],
                         centres[i][1]) <= btns_radius)
                {
                    if (i < 4) clr1 = i;
                    else if (i < 8) clr2 = i - 4;
                    else rule = i - 8;
                };
            };
        };
    };
    // Background show
    border[0].show_to(190, 0);
    border[1].show_to(0, 0);
    border[2].show_to(10, 0);
    border[3].show_to(10, 190);
    // Cells out
    cell *ptr = map[0];
    int dx, dy = 10;
    for (int j = 0; j < max_y; j++)
    {
        dx = 10;
        for (int i = 0; i < max_x; i++)
        {
            if (ptr->stat == cs_white)
            {
                b_bwcells.blt_fast(dx, dy, 0, 0, 6, 6);
            }
            else if (ptr->stat == cs_black)
            {
                b_bwcells.blt_fast(dx, dy, 6, 0, 6, 6);
            }
            else
            {
                b_cells.blt_fast(dx, dy, (ptr->stat % 18) * 6,
                                (ptr->stat / 18) * 6, 6, 6);
            }
            dx += 6;
            ptr++;
        };
        dy += 6;
    };
    // Balls out
    ball *bptr = balls;
    for (int i = 0; i < max_balls_count; i++)
    {
        if (bptr->present)
        {
            b_balls.blt_fast(10 + (int)bptr->x,
                             10 + (int)bptr->y,
                             bptr->stat * 6, 0, 6, 6);
        };
        bptr++;
    };
    // Show Timer
    show_number((cur_time / timer_hz) / 3600, 242, 14, 2);   // Hours
    show_number(((cur_time / timer_hz) / 60) % 60, 260, 14, 2);     // Minutes
    show_number((cur_time / timer_hz) % 60, 278, 14, 2);            // Seconds
    // Show statistic
    show_number(balls_count[0], 210, 174, 3);
    show_number(balls_count[1], 248, 174, 3);
    show_number(balls_count[2], 287, 174, 3);
    // Btns show
    buttons.blt_fast(centres[clr1][0] - btn_off,
                     centres[clr1][1] - btn_off,
                     clr1 * 31, 0, 31, 31);
    buttons.blt_fast(centres[clr2 + 4][0] - btn_off,
                     centres[clr2 + 4][1] - btn_off,
                     clr2 * 31, 31, 31, 31);
    buttons.blt_fast(centres[rule + 8][0] - btn_off,
                     centres[rule + 8][1] - btn_off,
                     rule * 31, 62, 31, 31);
    if (is_pause)
        playb.show_to(265, 36);
    // WON check
    if (won == 1)
    {
        gameend.show_to(50, 60);
    }
    else if (won == -1)
    {
        gameover.show_to(50, 60);
    };
    // Spec info out
/*
    double energy = 0;
    bptr = balls;
    for (i = 0; i < max_balls_count; i++)
    {
        if (bptr->present)
        {
            energy += sqrt(bptr->dx * bptr->dx + bptr->dy * bptr->dy);
        };
        bptr++;
    };
    show_number(abs(energy * 100), 0, 0, 10);
*/
    // Mouse show
    mouse_pos mp = mouse_get_pos();
    cur.blt_fast_safe(mp.x / 2, mp.y, m_step * 20, 0, 20, 20);
    if (++m_count >= m_max_count)
    {
        if (is_pause)
        {
            m_dir = -1;
            if (m_step + m_dir < 0) m_step = 1;
        }
        else if (m_dir == 1)
        {
            if (m_step + m_dir > m_cadres - 1) m_dir = -1;
        }
        else
        {
            if (m_step + m_dir < 0) m_dir = 1;
        };
        m_step += m_dir;
        m_count = 0;
    };
    refresh();
};
// --------------------------------------------------------------------------
void main()
{
    if (!mouse_init()) error("Mouse not present!\n");
    printf("Loading...\n");
    // Init
    load_bitmap_array(border, 4, "data\\bar");
    // load_bitmap_array(btns, max_btns, "data\\press");
    randomize();
    vga_open(vm_buffered);
    load_palette_from_file2("data\\mobl.pal");
    set_border_color(255);
    fill_screen(255);
    refresh();
    mouse_pos mp = mouse_get_last(0);
    // Work loop
    run_timer(timer_hz, 0);
    while(!done)
    {
        unsigned long old_time = timer_clicks;
        while (old_time == timer_clicks);
        timer_click();
    };
    stop_timer();
    // Close all
    vga_close();
};
// ==========================================================================
