#include "vga.h"
#include "mouse.h"
#include "sprites.h"
#include "timer.h"
#include "conio.h"
#include "string.h"
#include "stdlib.h"
#include "math.h"
#include "errors.h"
// --------------------------------------------------------------------------
enum
{
    timer_hz = 25,
    max_btns = 12,
    btns_radius = 10,
    exit_radius = 12,
    btn_off = 15,
    btn_width = 24,
    btn_height = 16,
    max_balls = 4,
    max_cells = 17,
    click_lim = 4,
    max_x = 30,
    max_y = 30,
    max_balls_count = 200,
    start_balls_count = 50,
    ball_radius = 3,
    m_cadres = 5,
    m_max_count = 3,
    ball_max_free_time = 90
};
enum ball_stat
{
    bs_red = 0, bs_green, bs_blue, bs_l_red, bs_l_green, bs_l_blue, bs_white
};
enum cell_stat
{
    cs_red_beg = 0, cs_red_end = 17,
    cs_green_beg = 18, cs_green_end = 35,
    cs_blue_beg = 36, cs_blue_end = 53,
    cs_white, cs_black
};
// --------------------------------------------------------------------------
struct cell
{
    int click;
    byte stat;
};
struct ball
{
    double x, y, dx, dy;
    byte stat, present;
    int count;
};
// ==========================================================================
inline int dist(int x1, int y1, int x2, int y2)
{
    return sqrt((double)(x1 - x2) * (x1 - x2) +
                (double)(y1 - y2) * (y1 - y2));
};
void show_number(long number, int x, int y, int space);
int ball_hit(int search_for, int start_index);
void create_ball(int status);
void destroy_ball(ball *bptr);
void load_bitmap_array(bitmap *ptr, int count, char *name);
void new_game_init();
void do_tick();
void timer_click();
void main();
// ==========================================================================
